<?php
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: top.php,v 1.1 2000/07/20 11:53:03 jmayer Exp $

include("ServerScriptHelper.php");
include("ArrayPacker.php");
include("uifc/PagedBlock.php");
include("uifc/MultiChoice.php");
include("uifc/Option.php");

$iam = '/base/firewall/top.php';

// standard uifc header:
$serverScriptHelper = new ServerScriptHelper() or die ("no server-script-helper");
$i18n = $serverScriptHelper->getI18n("base-firewall");
$confirm_removal=$i18n->get('confirm_removal');
$cceClient = $serverScriptHelper->getCceClient() or die ("no CCE");
$factory = $serverScriptHelper->getHtmlComponentFactory("base-firewall", $iam);
$page = $factory->getPage();
print($page->toHeaderHtml()); 

///////////////////////////////////////////////////////////////////
// identify objects
///////////////////////////////////////////////////////////////////
$sys_oids = $cceClient->find("System");

///////////////////////////////////////////////////////////////////
// handle events
///////////////////////////////////////////////////////////////////
if ($HTTP_GET_VARS['confirm']) {
  $cceClient->set($sys_oids[0], "Firewall", array('watchdog' => '0'));
}
if ($HTTP_GET_VARS['disable']) {
  $cceClient->set($sys_oids[0], "Firewall", array('enabled' => '0'));
}

//////////////////////////////////////////////////////////////////////////
// load useful objects.
//////////////////////////////////////////////////////////////////////////
$sys_obj = $cceClient->get($sys_oids[0], "Firewall");

// block:
$block = new PagedBlock($page, "FirewallTop", 
  $factory->getLabel("FirewallTop",true));

// Dirty flag:
if ($sys_obj['enabled'] && $sys_obj['dirty']) {
  $block->addDivider($factory->getLabel("firewall-is-dirty-message"));
}

// multibutton:
$i18n = $factory->getI18n();
$chain_label = array();
$rules_url = '/base/firewall/rules.php';
// $chain_label[$i18n->get('Select_chain')] = $iam;
$chain_label[$i18n->get('chain_input')] = $rules_url . "?chain=input";
$chain_label[$i18n->get('chain_forward')] = $rules_url . "?chain=forward";
$chain_label[$i18n->get('chain_output')] = $rules_url . "?chain=output";
$block->addFormField(
  $factory->getMultiButton('Selectchain', 
    array_values($chain_label),
    array_keys($chain_label)
  ),
  $factory->getLabel("EditRuleChain", true)
);

// firewall has three possible states, and different buttons
// are visible in each state:
//    enabled: "disable firewall"
//    disabld: "enable firewall"
//    enabled+dirty: "disable firewall", "commit changes"

if ($sys_obj['enabled'] && $sys_obj['dirty']) {
  $block->addButton($factory->getButton('/base/firewall/enable1.php', 'commit-changes-button'));
}

if ($sys_obj['enabled']) {
  $block->addButton($factory->getButton($iam . '?disable=1', 
    'disable-firewall-button'));
} else {
  $block->addButton($factory->getButton('/base/firewall/enable1.php',
    'enable-firewall-button'));
}

print $block->toHtml();
print $page->toFooterHtml();
